Bug 27060 - [965] piglit glsl-fs-raytrace failure due to lack of function calls.
[965] piglit glsl-fs-raytrace failure due to lack of function calls.
Status: RESOLVED FIXED
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/i965
git
x86-64 (AMD64) Linux (All)
: medium major
Assigned To: Eric Anholt
:
Depends on:
Blocks: 29044
  Show dependency treegraph
 
Reported: 2010-03-13 10:28 UTC by Kristof Ralovich
Modified: 2010-08-18 21:12 UTC (History)
1 user (show)

See Also:


Attachments
misrendered GLSL testcase (17.03 KB, text/x-csrc)
2010-03-13 10:28 UTC, Kristof Ralovich
Details
updated test case (17.04 KB, text/plain)
2010-03-13 10:42 UTC, Kristof Ralovich
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Kristof Ralovich 2010-03-13 10:28:31 UTC
Created attachment 34029 [details]
misrendered GLSL testcase

The attached testcase doesn't render correctly on a GM45.
Comment 1 Kristof Ralovich 2010-03-13 10:31:34 UTC
If you are here, please have a look at https://bugs.freedesktop.org/show_bug.cgi?id=26691 too.
Comment 2 Kristof Ralovich 2010-03-13 10:42:27 UTC
Created attachment 34030 [details]
updated test case

The previous test-case forced SW rendering which hides the bug by rendering correctly.
Comment 3 Eric Anholt 2010-03-14 10:41:58 UTC
commit 48dca99feb394febc3af44e14f23fb12a9cc9204
Author: Eric Anholt <eric@anholt.net>
Date:   Wed Mar 10 11:00:40 2010 -0800

    i965: Add support for the CMP opcode in the GLSL path.
    
    This would be triggered by use of sqrt() along with control flow.
    Fixes piglit-fs-sqrt-branch and a bug in Yo Frankie!.
Comment 4 Kristof Ralovich 2010-03-18 19:41:22 UTC
(In reply to comment #3)
> commit 48dca99feb394febc3af44e14f23fb12a9cc9204
> Author: Eric Anholt <eric@anholt.net>
> Date:   Wed Mar 10 11:00:40 2010 -0800
> 
>     i965: Add support for the CMP opcode in the GLSL path.
> 
>     This would be triggered by use of sqrt() along with control flow.
>     Fixes piglit-fs-sqrt-branch and a bug in Yo Frankie!.
> 

I have re-run the test case with today's Mesa master 8df65e98998b4c104db30cbba8a38be7eb2a9acd (including the above referred patch) and drm master c1c8bbf80b1f734e23996bf805dc78f32ebaf56f and the misrendering still exists. The warning has gone away for the sqrt instruction though. Please run the test case with LIBGL_ALWAYS_SOFTWARE=1 ./fsraytrace to what the normal rendering should be.
Comment 5 Eric Anholt 2010-08-16 23:41:51 UTC
This is fixed with the merge of GLSL2.
Comment 6 Kristof Ralovich 2010-08-18 21:12:21 UTC
I can confirm, it is working on GM45 with upstream mesa. Nice work! Thanks!